﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace HeuristicLab.Services.Deployment.DataAccess {
  [DataContract(Name = "ProductDescription")]
  public class ProductDescription {

    [DataMember(Name = "Id")]
    private long id;
    internal long Id {
      get { return id; }
      set { id = value; }
    }

    [DataMember(Name = "Name")]
    private string name;
    public string Name {
      get { return name; }
    }

    [DataMember(Name = "Version")]
    private Version version;
    public Version Version {
      get { return version; }
    }

    [DataMember(Name = "Plugins")]
    private IEnumerable<PluginDescription> plugins;
    public IEnumerable<PluginDescription> Plugins {
      get { return plugins; }
    }

    internal ProductDescription(long id, string name, Version version, IEnumerable<PluginDescription> plugins) {
      this.id = id;
      this.name = name;
      this.version = version;
      this.plugins = new List<PluginDescription>(plugins).AsReadOnly();
    }

    public ProductDescription(string name, Version version, IEnumerable<PluginDescription> plugins)
      : this(0, name, version, plugins) {
    }

    public ProductDescription(string name, Version version) : this(name, version, Enumerable.Empty<PluginDescription>()) { }
  }
}
